<?php
/**
 * Template and actions for options page.
 */
//For nonce.
global $current_user;
//Setup plugin options.
$options = get_option('facebookalbum', FB_Album::default_options());

//If nonce, do update
if (isset($_POST["fbalbum_nonce"])) :
	$options = $_POST['facebookalbum'];
	update_option('facebookalbum', $options);
	echo '<div class="updated"><p><strong>Facebook Albums has been updated</strong></p></div>
		<script>window.location = window.location.protocol + \'//\'+ window.location.hostname + window.location.pathname + \'?page=facebook-album\'</script>';
endif;

if(isset($_GET['reset_application']) && wp_verify_nonce($_GET['reset_application'], $current_user->data->user_email)) :
	unset($options['app_id']);
	unset($options['app_secret']);
	update_option('facebookalbum', $options);
	echo '<div class="updated"><p><strong>Facebook API application has been removed.</strong></p></div>
			<script>window.location = window.location.protocol + \'//\'+ window.location.hostname + window.location.pathname + \'?page=facebook-album\'</script>';
endif;

 ?>
		<?php //echo '<pre>';//global $current_user; print_r($current_user);echo'</pre>'; ?>
			<div class="wrap">
				<?php screen_icon(); ?>
				<h2>Facebook Album Options</h2>
				<div id="facebook-album-content" class="postbox-container" style="">
				<form method="post" action="" name="options-facebookalbum">
				<?php 	wp_nonce_field(basename(__FILE__), 'fbalbum_nonce'); ?>
				<div class="settings-box">
					<h2>General Settings</h2>
					<div class="checkbox-group">
						<p><label><input type="checkbox" value="on" name="facebookalbum[order]" id="fbalbum_order" <?php checked($options['order'], 'on'); ?>/> Reverse the order of the Facebook Album photo feed.</label>
							<span class="note">Note: Facebook does not support a "order" attribute for Graph API calls. This simply reverse the order of the photos received from Facebook.</span>
						</p>
						<p><label><input type="checkbox" value="on" name="facebookalbum[title]" id="fbalbum_title" <?php checked($options['title'], 'on'); ?>/> Display album title.</label></p>
						<p><label><input type="checkbox" value="on" name="facebookalbum[photo_title]" id="photo_title" <?php checked($options['photo_title'], 'on'); ?>/> Display photo description in lightbox.</label></p>
					</div>
					<p><label for="fbalbum_size">Thumbnail Size</label>: 
						<select name="facebookalbum[size]" id="fbalbum_size" value="" class="regular-text">
							<option value="8" <?php selected($options['size'], 8) ?>>Smaller</option>
							<option value="6" <?php selected($options['size'], 6) ?>>Small</option>
							<option value="5" <?php selected($options['size'], 5) ?>>Medium</option>
							<option value="4" <?php selected($options['size'], 4) ?>>Big</option>
							<option value="3" <?php selected($options['size'], 3) ?>>Bigger</option>
							<option value="2" <?php selected($options['size'], 2) ?>>Large</option>
						</select>
					</p>
					<div class="app-settings">
						<?php if(!FB_Album::verify_app_information()) : ?>
						<p>If you wish to use <strong>personal albums</strong> you will need to create a Facebook app and enter in the App ID and App Secret below.</p>
						<p><label>App ID</label><input type="text" name="facebookalbum[app_id]" value="<?php echo $options['app_id']; ?>" /></p>
						<p><label>App Secret</label><input type="text" name="facebookalbum[app_secret]" value="<?php echo $options['app_secret']; ?>" /></p>
						<?php else:
						// Get User ID
						$user = FB_Album::$facebook_sdk->getUser();
						if ($user) {
						  try {
						    // Proceed knowing you have a logged in user who's authenticated.
						    $user_profile = FB_Album::$facebook_sdk->api('/me');
						  } catch (FacebookApiException $e) {
						    echo '<div class="error"><p><strong>OAuth Error</strong>Error added to error_log: '.$e.'</p></div>';
						    error_log($e);
						    $user = null;
						  }
						}
						
						// Login or logout url will be needed depending on current user state.
						$app_link_text = $app_link_url = null;
						if ($user) {
						  $app_link_url = FB_Album::$facebook_sdk->getLogoutUrl(array('next' => admin_url()));
							$app_link_text = "Logout of your app";
						} else {
						  $app_link_url = FB_Album::$facebook_sdk->getLoginUrl();
						    $app_link_text = 'Log into Facebook with your app';
						} ?>
							<input type="hidden" name="facebookalbum[app_id]" value="<?php echo $options['app_id']; ?>" />
							<input type="hidden" name="facebookalbum[app_secret]" value="<?php echo $options['app_secret']; ?>" />
							<div style="float: right; margin: 10px;"><span style="margin: 0 10px;"><?php echo $user_profile['name']; ?></span><img src="https://graph.facebook.com/<?= $user_profile['id'] ?>/picture?type=square" style="vertical-align: middle"/></div>
							<ul>
								<li><a href="https://developers.facebook.com/apps/<?php echo $options['app_id']; ?>" target="_blank">View your application's settings.</a></li>
								<li><a href="<?php echo $app_link_url; ?>"><?php echo $app_link_text; ?></a></li>
							</ul>
							<div style="clear: both;">&nbsp;</div>
							<p>Having issues once logged in? Try <a href="?page=facebook-album&amp;reset_application=<?php echo wp_create_nonce($current_user->data->user_email); ?>">resetting application data.</a> <em>warning: removes App ID and App Secret</em></p>
						<?php endif; ?>
					</div>
				</div>
				<div class="settings-box">
					<h2>Colorbox Settings</h2>
					<p><label><input type="checkbox" value="true" name="facebookalbum[colorbox][enabled]" id="fbalbum_order" <?php checked($options['colorbox']['enabled'], 'true'); ?>/> Enable Colorbox</label></p>
					<div class="colorbox-options" style="<?php if($options['colorbox']['enabled'] != 'true') echo 'display:none'; ?>">
						<p><label>Opacity of Colorbox overlay <input type="number" min="0.00" max="1.00" name="facebookalbum[colorbox][opacity]" step="0.01" value="<?php echo $options['colorbox']['opacity'] ?>"></label></p>
						<p><label for="transition">Transition Type</label>: 
							<select name="facebookalbum[colorbox][transition]" id="trainsition" value="" class="regular-text">
								<option value="none" <?php selected($options['colorbox']['transition'], 'none') ?>>None</option>
								<option value="elastic" <?php selected($options['colorbox']['transition'], 'elastic') ?>>Elastic</option>
								<option value="fade" <?php selected($options['colorbox']['transition'], 'fade') ?>>Fade</option>
							</select>
						</p>
					</div>
				</div>
				<div class="settings-box">
					<h2>Widget Options</h2>
					<p>You have the option to specify a different Facebook Album URL for each page.</p>	
					<div style="height: 300px; overflow: auto; padding-left: 10px; border-left: 2px solid #e6e6e6;">
						<?php foreach( get_pages() as $page): ?>
						<p><label for="wp_page_<?php echo $page -> ID; ?>"><?php echo $page -> post_title; ?></label><br/><input type="text" size="60" name="facebookalbum[pages][<?php echo $page -> ID; ?>]" id="wp_page_<?php echo $page -> ID; ?>" value="<?php echo $options['pages'][$page->ID] ?>"></p>
						<?php endforeach; ?>
						</div>
				</div>
					  <p class="submit">
					  <input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
					  </p>
				</form>
				</div>
				<div id="facebook-album-meta" class="postbox-container" style="width: 261px;">
					<div class="author">
						<div class="by">by</div>
						<div class="name">matt glaman</div>
						<div class="website">
							<a href="http://glamanate.com/?utm_source=fbalbum_options&utm_medium=website&utm_campaign=fbalbum" target="_blank">glamanate.com</a>
						</div>
					</div>
					<div class="donate">
						<p>Please support this plugin's development so more features and capabilities can be added!</p>
						<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=CTT2K9UJZJ55S" class="btn" target="_blank">Donate Now</a>
					</div>
					<div class="video">
						<iframe width="420" height="315" src="http://www.youtube.com/embed/ZiNJPg6sv1I?rel=0" frameborder="0" allowfullscreen></iframe>
						<caption>How to use shortcode in Pages or Posts</caption>
						<div style="height:25px;">&nbsp;</div>
						<iframe width="420" height="315" src="http://www.youtube.com/embed/3p_OZ7qbxk4?rel=0" frameborder="0" allowfullscreen></iframe>
						<caption>How to setup a Facebook app</caption>
					</div>
					<div class="news">
						<h3>Plugin News</h3>
					<?php
							$news_widget = array(
								'link' => 'http://glamanate.com',
								'url' => 'http://glamanate.com/category/facebook-album-news/feed/',
								'title' => 'Plugin News',
								'items' => 3,
								'show_summary' => 0,
								'show_author' => 0,
								'show_date' => 0
							);
						echo '<div class="rss-widget">';
						wp_widget_rss_output( $news_widget );
						echo "</div>";
						?>
					</div>
				</div>
			</div>