<?php
/**
 * The Facebook Album Widget
 * Displays 6 
 */

add_action( 'widgets_init', create_function( '', 'return register_widget( "FB_Album_Widget" );' ) );
class FB_Album_Widget extends WP_Widget {

  public function __construct() {
    parent::__construct( 'facebook-album', 'Facebook Album', array('description' => 'Paste a Facebook Page album URL and display the most recent photos as a widget.') );
		//Widget has been set up
	}

 	public function form( $instance ) {
		//The form you see on the admin side
    	$instance = wp_parse_args( (array) $instance, array( 'title' => '', 'url' => '', 'thumb_size' => '', 'limit' => '6') );
		$title = $instance['title'];
    	$url = $instance['url'];
		$thumb_size = $instance['thumb_size'];
		$limit = $instance['limit'];
		?>
		<p><label for="<?php echo $this->get_field_id('title'); ?>">Title:</label> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo attribute_escape($title); ?>" /></p>
	  	<p><label for="<?php echo $this->get_field_id('url'); ?>">Default Facebook Album URL: <input class="widefat" id="<?php echo $this->get_field_id('url'); ?>" name="<?php echo $this->get_field_name('url'); ?>" type="text" value="<?php echo attribute_escape($url); ?>" /></label></p>
	  	<p><label for="<?php echo $this->get_field_id('thumb_size'); ?>">Thumbnail Size:</label><select id="<?php echo $this->get_field_id('thumb_size'); ?>" name="<?php echo $this->get_field_name('thumb_size'); ?>">
							<option value="8" <?php selected($thumb_size, 8) ?>>Smaller</option>
							<option value="6" <?php selected($thumb_size, 6) ?>>Small</option>
							<option value="5" <?php selected($thumb_size, 5) ?>>Medium</option>
							<option value="4" <?php selected($thumb_size, 4) ?>>Big</option>
							<option value="3" <?php selected($thumb_size, 3) ?>>Bigger</option>
							<option value="2" <?php selected($thumb_size, 2) ?>>Large</option>
	  		</select>
	  	<p><label for="<?php echo $this->get_field_id('limit'); ?>">Number of pictures: <input id="<?php echo $this->get_field_id('limit'); ?>" name="<?php echo $this->get_field_name('limit'); ?>" type="text" value="<?php echo attribute_escape($limit); ?>" size="3"/></label></p>
	  	</p>
		<?php		
	}

	public function update( $new_instance, $old_instance ) {
		//Saves the options
		
		    $instance = $old_instance;
			$instance['title'] = $new_instance['title'];
		    $instance['url'] = $new_instance['url'];
			$instance['thumb_size'] = $new_instance['thumb_size'];
			$instance['limit'] = $new_instance['limit'];
		    return $instance;
	}

	public function widget( $args, $instance ) {
		extract($args);
		
		echo $before_widget;
		if(!empty($instance['title']))
			echo '<h3 class="widget-title">'.esc_attr($instance['title']).'</h3>';
		
		/** Check if we should show a specified album for this page/post **/
		FB_Album::load_options();
		$wp_pages = FB_Album::$options['pages'];
		global $post;
		$facebook_album_url = (!empty($wp_pages[$post->ID])) ? $wp_pages[$post->ID] : $instance['url'];
		if($facebook_album_url != '') {
			FB_Album::_set_album_url( $facebook_album_url );
		} else { 
			echo 'No Facebook Album specified.';
			echo $after_widget; 
			return;
		}
	
		if(!FB_Album::_get_album_id()) {
			echo 'The Facebook album ID came up empty, double check the URL';
			echo $after_widget; 
			return;
		} else {
			FB_Album::_enqueue_resources();
			
			if(!FB_Album::_get_album_id() || !($fb = FB_Album::_get_graph_results($instance['limit'])) ) {
				echo 'Sorry, there was an error loading the Facebook album, please refresh the page and try again.';
				echo $after_widget;
				return; 
			}
			
			if(!$fb['photos']) {
				echo 'Album not found, or is not public.';
			} else {   ?> 
				<?php if( $title )
					echo '<h2><a href="' . FB_Album::_clean_url(FB_Album::_get_album_url()) . '" target="_blank"">' . $fb['name'] . '</a></h2>'; ?>
					
				<div class="fbalbum fbalbum-widget"> <?php
				//Reverse array to show oldest to newest
				if(FB_Album::$options['order'])
					$fb['photos']['data'] = array_reverse($fb['photos']['data']);
								
				foreach ($fb['photos']['data'] as $img) :
					$img_info = $img['images'][$instance['thumb_size']]; ?>
					<div class="item">
						<a href="<?php echo FB_Album::_clean_url($img['source']) ?>" target="_blank" rel="lightbox" class="fbalbum cboxElement">
							<div class="image size-<?php echo $instance['thumb_size']; ?>" style="background-image: url('<?php echo FB_Album::_clean_url($img_info['source']) ?>');">&nbsp;</div>
						</a>
					</div>
				
					<?php
				endforeach;
				echo '</div>';
				echo FB_Album::build_colorbox();
			}
		}
		echo $after_widget; 
	}

}
?>